#include <iostream>
#include "Test.h"

int main(int argc, char** argv)
{
	if (argc < 2) return 254;
	try
	{
		CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
		Test::List mylist;
		mylist.entries.length(1);
		mylist.entries[0].entries.length(1);

		Test::Envelope cinfo;
		cinfo.payload <<= mylist;
		
		CORBA::Object_var obj = orb->string_to_object(argv[1]);
		Test::TestServer_var ts = Test::TestServer::_narrow(obj);
		ts->call(cinfo);
	}
	catch(CORBA::Exception& e)
	{
		std::cerr << "CORBA Exception " << typeid(e).name() <<  std::endl;
	}
	catch(...)
	{
		std::cerr << "Exception" << std::endl;
	}
}
