#include <iostream>
#include "Test.h"

class TestServer_impl: virtual public POA_Test::TestServer, virtual public PortableServer::RefCountServantBase
{
public:
	TestServer_impl() {}

	void call(const Test::Envelope& e)
	{
		std::cout << "Received call" << std::endl;
	}
};


int main(int argc, char** argv)
{
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
	CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
	PortableServer::POA_var root_poa = PortableServer::POA::_narrow(obj);
	PortableServer::POAManager_var pman = root_poa->the_POAManager();
	PortableServer::LifespanPolicy_var lifespan = root_poa->create_lifespan_policy(PortableServer::PERSISTENT); 
	PortableServer::IdAssignmentPolicy_var assign = root_poa->create_id_assignment_policy(PortableServer::USER_ID); 
	CORBA::PolicyList policy_list; 
	policy_list.length(2); 
	policy_list[0] = PortableServer::LifespanPolicy::_duplicate(lifespan); 
	policy_list[1] = PortableServer::IdAssignmentPolicy::_duplicate(assign); 

	PortableServer::POA_var TestServer_poa = root_poa->create_POA("TestServer", pman, policy_list); 

	TestServer_impl impl;
	PortableServer::ObjectId_var implId = PortableServer::string_to_ObjectId("TestServer");
	TestServer_poa->activate_object_with_id(implId, &impl);

	CORBA::Object_var test_obj = impl._this();
	CORBA::String_var ior = orb->object_to_string(test_obj);
	std::cout << ior << std::endl;
	pman->activate();
	orb->run();
}
